#include "setcurs.ch"
#include "inkey.ch"
#include "box.ch"

#define TRUE			 .T.
#define FALSE 		 .F.
#define ALIAS 		 1
#define BOXTOP		 2
#define BOXLEFT 	 3
#define BOXBOTTOM  4
#define BOXRIGHT	 5
#define BOXTYPE 	 6
#define BOXBORDER  7
#define BOXINCOLOR 8

FUNCTION BrowseIt()
	LOCAL aoBrowse := ARRAY(3)
	LOCAL nCursSave
	LOCAL cSaveScr, nSaveRow
	LOCAL lMore
	LOCAL nKey
	LOCAL n, nBP
	// Save Screen Information
	cSaveScr := SAVESCREEN(0,0,MAXROW(),MAXCOL())
	nSaveRow := MAXROW()
	//Open DBFs and Indexes
	DBUSEAREA(TRUE,,"PATIENT","PATIENT",TRUE,TRUE)
	DBSETINDEX("PATIENT1")
	DBUSEAREA(TRUE,,"INVOICE","INVOICE",TRUE,TRUE)
	DBSETINDEX("INVOICE3")
	DBUSEAREA(TRUE,,"PAYHIST","PAYHIST",TRUE,TRUE)
	DBSETINDEX("PAYHIST1")
	//Start Screen Buffering
	DISPBEGIN()
	CLEAR SCREEN
	SETMODE(43,80)
	//Set up Browse
	aoBrowse[1] := PATI1Browse()
	aoBrowse[1]:goTop()
	DispBrowse(aoBrowse[1])
	aoBrowse[2] := INVO2Browse()
	aoBrowse[2]:goTop()
	DispBrowse(aoBrowse[2])
	aoBrowse[3] := PAYH3Browse()
	aoBrowse[3]:goTop()
	DispBrowse(aoBrowse[3])
	DISPEND()
	nCursSave := SETCURSOR(SC_NONE)
	//Set Browse pointer to 1st Browse
	*nBP := LEN(aoBrowse)
	nBP := 1
	DispBrowse(aoBrowse[nBP])
	//Main Browse display loop
	lMore := TRUE
	DO WHILE lMore
		nKey := 0
		//Stabilize Browse until Stable or keypress
		DO WHILE (nKey	:= INKEY()) == 0 .AND. !aoBrowse[nBP]:stabilize()
		ENDDO
		IF aoBrowse[nBP]:stable
			//Alert for TOP or BOTTOM hit
			IF aoBrowse[nBP]:hitTop .OR. aoBrowse[nBP]:hitBottom
				TONE(125,0)
			ENDIF
			//Update other browse screens in case relation is set
			IF !EMPTY(DBRELATION(1))
				DrawAll(aoBrowse, nBP)
			ENDIF

			aoBrowse[nBP]:hilite()

			//Get new keystroke
			nKey := INKEY(0)
		ENDIF

		//Apply the keystroke to the browse
		lMore := ApplyKey(aoBrowse,nKey,@nBP)

	ENDDO

	//Restore Original Screen/Cursor
	DBCLOSEALL()
	SETCURSOR(nCursSave)
	CLEAR SCREEN
	SETMODE(25,80)
	RESTSCREEN(0,0,MAXROW(),MAXCOL(),cSaveScr)
	SETPOS(nSaveRow,0)
RETURN(NIL)

PROCEDURE ForceStable(oBrowse)
	//Note use of DISPBEGIN() and DISPEND() for smooth screen display
	DISPBEGIN()
	DO WHILE .NOT. oBrowse:stabilize()
	ENDDO
	DISPEND()
RETURN

FUNCTION ApplyKey(aoBrowse,nKey, nBP)
	LOCAL lMore := TRUE
	//Handle the keystrokes - more could be added
	DO CASE
		CASE nKey == K_UP
			aoBrowse[nBP]:up()
		CASE nKey == K_DOWN
			aoBrowse[nBP]:down()
		CASE nKey == K_HOME
			aoBrowse[nBP]:home()
		CASE nKey == K_END
			aoBrowse[nBP]:end()
		CASE nKey == K_PGUP
			aoBrowse[nBP]:pageUp()
		CASE nKey == K_PGDN
			aoBrowse[nBP]:pageDown()
		CASE nKey == K_CTRL_PGDN
			aoBrowse[nBP]:goBottom()
		CASE nKey == K_CTRL_PGUP
			aoBrowse[nBP]:goTop()
		CASE nKey == K_TAB
			IF nBP == 2
				nBP := 1
			ELSE
				nBP := 2
			ENDIF
		CASE nKey == K_ESC
			//Get us out of the program
			lMore := FALSE
	ENDCASE
RETURN(lMore)

STATIC FUNCTION GoNext(nToSkip, bWhileCond)
	LOCAL nSkipped := 0, nDirection
	//How to SKIP records
	nDirection := IIF(nToSkip > 0, 1, -1)
	DO WHILE nSkipped != nToSkip .AND. EVAL(bWhileCond) .AND. ;
		!EOF() .AND. !BOF()
		SKIP nDirection
		nSkipped += nDirection
	ENDDO
	IF EOF()
		SKIP -1
		nSkipped--
	ELSEIF BOF()
		GOTO RECNO()
		nSkipped++
	ELSEIF !EVAL(bWhileCond)
		SKIP -nDirection
		nSkipped += -nDirection
	ENDIF
RETURN(nSkipped)

STATIC FUNCTION GoTop(bWhileCond)
	DO WHILE !BOF()
		SKIP -1
		IF !EVAL(bWhileCond)
			SKIP
			EXIT
		ENDIF
	ENDDO
RETURN(NIL)

STATIC FUNCTION GoBottom(bWhileCond)
	DO WHILE EVAL(bWhileCond) .AND. !EOF()
		SKIP
	ENDDO
	SKIP -1
RETURN(NIL)

FUNCTION PATI1Browse(oBrowse)
	LOCAL oCol
	//This sets up the TOP window's TBROWSE
	SELECT PATIENT
	GO TOP
	SET RELATION TO UPPER(PATIENT->pid) INTO INVOICE
	oBrowse := TBrowseDB(01,01,13,78)
	//Dummy formula in block
	oBrowse:skipBlock := { |x| GoNext ( x, { ||UPPER(pid)=pid } ) }
	oBrowse:GoTopBlock := { || GoTop ( { ||UPPER(pid)=pid } ) }
	oBrowse:GoBottomBlock := { || GoBottom ( { ||UPPER(pid)=pid } ) }
	//define column attributes
	oBrowse:colSep	 := "  "
	oBrowse:headSep  := ""
	oBrowse:footSep  := ""
	oBrowse:colorSpec := "W+/BG,N/W"
	oBrowse:autoLite := FALSE
	//Array loaded into cargo
	oBrowse:cargo := {SELECT(), 0, 0,14,79,B_SINGLE,"W+/BG","W+/BG"}
	oCol := TBColumnNew("Pat ID",FIELDBLOCK("PID"))
	oCol:cargo := {FIELDBLOCK("PID"),""}
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew(PADR("Name",20),{||PADR(TRIM(PLNAME)+", "+PFNAME,20)})
	oCol:cargo := {{||PADR(TRIM(PLNAME)+", "+PFNAME,20)},""}
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Insur",FIELDBLOCK("PCODE"))
	oCol:cargo := {FIELDBLOCK("PCODE"),""}
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Amt Owed",FIELDBLOCK("AMTOWE"))
	oCol:cargo := {FIELDBLOCK("AMTOWE"),""}
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Phone",FIELDBLOCK("PPHONE"))
	oCol:cargo := {FIELDBLOCK("PPHONE"),""}
  oBrowse:addColumn(oCol)
RETURN(oBrowse)

FUNCTION INVO2Browse(oBrowse)
	LOCAL oCol
	SELECT INVOICE
	DBSEEK(UPPER(PATIENT->pid))
	SET RELATION TO INVOICE->INVOICE INTO PAYHIST
	oBrowse := TBrowseDB(16,01,27,78)
	//Now skipblock has a real formula to evaluate
	oBrowse:skipBlock := { |x| GoNext(x,{||UPPER(pid)=PATIENT->pid } ) }
	oBrowse:GoTopBlock := { || GoTop( {||UPPER(pid)=PATIENT->pid } ) }
	oBrowse:GoBottomBlock := { || GoBottom( {||UPPER(pid)=PATIENT->pid } ) }
	//define column attributes
	oBrowse:colSep	 := "  "
	oBrowse:headSep  := ""
	oBrowse:footSep  := ""
	oBrowse:colorSpec := "W+/RB,N/W,W+/RB,W/RB,GR+/RB,R*/RB,N/RB"
	oBrowse:autoLite := FALSE
	//Here's that cargo slot again
	oBrowse:cargo := {SELECT(),15,00,28,79,B_SINGLE,"W+/RB","W+/RB"}
	oCol := TBColumnNew("Invoice #",FIELDBLOCK("INVOICE"))
	oCol:cargo := {FIELDBLOCK("INVOICE"),""}
	//Notice the color changes
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},{1,2} ) }
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Inv Date",FIELDBLOCK("INVDATE"))
	oCol:cargo := {FIELDBLOCK("INVDATE"),""}
	//More color changes
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},if(DATE()-INVDATE>90,{6,2},if(DATE()-INVDATE>60,{5,2},if(DATE()-INVDATE>30,{7,2},{1,2}))))}
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Remaining",FIELDBLOCK("AMTREMAIN"))
  oCol:cargo := {FIELDBLOCK("AMTREMAIN"),""}
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},{1,2} ) }
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Inv Amt",FIELDBLOCK("INVTOTAL"))
	oCol:cargo := {FIELDBLOCK("INVTOTAL"),""}
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},{1,2} ) }
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Deduct",FIELDBLOCK("DEDUCT"))
	oCol:cargo := {FIELDBLOCK("DEDUCT"),""}
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},{1,2} ) }
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Payments",FIELDBLOCK("PAYMENTS"))
	oCol:cargo := {FIELDBLOCK("PAYMENTS"),""}
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},{1,2} ) }
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Write Off",FIELDBLOCK("WRITEOFF"))
	oCol:cargo := {FIELDBLOCK("WRITEOFF"),""}
	oCol:colorBlock := { || if(AMTREMAIN=0.00,{4,2},{1,2} ) }
  oBrowse:addColumn(oCol)
RETURN(oBrowse)

FUNCTION PAYH3Browse(oBrowse)
	LOCAL oCol
	SELECT PAYHIST
	DBSEEK(UPPER(INVOICE->INVOICE))
	oBrowse := TBrowseDB(30,01,41,78)
	oBrowse:skipBlock := { |x| GoNext ( x,{ ||UPPER(invoice)=UPPER(INVOICE->invoice) } ) }
	oBrowse:GoTopBlock := { || GoTop ( { ||UPPER(invoice)=UPPER(INVOICE->invoice) } ) }
	oBrowse:GoBottomBlock := { || GoBottom ( { ||UPPER(invoice)=UPPER(INVOICE->invoice) } ) }
	//define column attributes
	oBrowse:colSep	 := "  "
	oBrowse:headSep  := ""
	oBrowse:footSep  := ""
	oBrowse:colorSpec := "W+/R,N/W"
	oBrowse:autoLite := FALSE
	oBrowse:cargo := {SELECT(),29,00,42,79,B_SINGLE,"W+/R","W+/R"}
	oCol := TBColumnNew("Invoice #",FIELDBLOCK("INVOICE"))
	oCol:cargo := {FIELDBLOCK("INVOICE"),""}
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Pymt Date",FIELDBLOCK("PAYDATE"))
	oCol:cargo := {FIELDBLOCK("PAYDATE"),""}
	oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Pymt Code",FIELDBLOCK("PAYBY"))
	oCol:cargo := {FIELDBLOCK("PAYBY"),""}
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Write Off",FIELDBLOCK("WRITEOFF"))
	oCol:cargo := {FIELDBLOCK("WRITEOFF"),""}
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Deductible",FIELDBLOCK("DEDUCT"))
	oCol:cargo := {FIELDBLOCK("DEDUCT"),""}
  oBrowse:addColumn(oCol)
	oCol := TBColumnNew("Payment",FIELDBLOCK("PAYMENTS"))
	oCol:cargo := {FIELDBLOCK("PAYMENTS"),""}
  oBrowse:addColumn(oCol)
RETURN(oBrowse)

FUNCTION DrawAll(aoBrowse, nBP)
	LOCAL n
	//Redraw the TBROWSE screens
	SETCOLOR("W/N")
	//Do it in memory for smoothness
	DISPBEGIN()
	CLEAR SCREEN
	FOR n := 1 TO LEN(aoBrowse)
			DispBrowse(aoBrowse[n])
	NEXT
	DispBrowse(aoBrowse[nBP])
	DISPEND()
RETURN(NIL)

FUNCTION DispBrowse(oBrowse)
	//Here is where the CARGO array parameters are used to display the BOX
	SELECT(oBrowse:cargo[ALIAS])
	DISPBEGIN()
	@ oBrowse:cargo[BOXTOP],oBrowse:cargo[BOXLEFT] CLEAR TO oBrowse:cargo[BOXBOTTOM], oBrowse:cargo[BOXRIGHT]
	DISPBOX(oBrowse:cargo[BOXTOP],oBrowse:cargo[BOXLEFT], ;
					oBrowse:cargo[BOXBOTTOM], oBrowse:cargo[BOXRIGHT], ;
					oBrowse:cargo[BOXTYPE], oBrowse:cargo[BOXBORDER] )
	oBrowse:refreshAll()
	ForceStable(oBrowse)
	DISPEND()
RETURN(NIL)

